/*
 * Class_Serial.cpp
 *
 * Created: 2016/02/17 13:57:48
 *  Author: Yuhei MATSUMURA
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include "Class_Serial.hpp"

//------------Class_Serial Class̃o-------------
Class_Serial::Class_Serial(volatile uint8_t *setUCSRnA, volatile uint8_t *setUCSRnB, volatile uint8_t *setUCSRnC, volatile uint16_t *setUBRRn, volatile uint8_t *setUDRn){
	UCSRnA = setUCSRnA;
	UCSRnB = setUCSRnB;
	UCSRnC = setUCSRnC;
	UBRRn = setUBRRn;
	UDRn = setUDRn;
	head = 0;
	tail = 0;
	queue_num = 0;
}
void Class_Serial::begin(uint16_t SPD_UBRRn){
	//{[h
	*UCSRnA = 0b00000010;
	//M荞݋AUARTM
	*UCSRnB = 0b10011000;
	*UCSRnC = 0b00000110;
	*UBRRn  = SPD_UBRRn;
}
void Class_Serial::	accept_intterupt(){
	sei();
}
void Class_Serial::send_char(uint8_t input){
	while( !((*UCSRnA) & 0b00100000 ) );//M܂őҋ@
	*UDRn = input;
}
void Class_Serial::send_print(const char *input){
	for(int i = 0; *(input + i) != '\0'; i++){
		send_char( *(input+i) );
	}
}
void Class_Serial::send_println(const char *input){
	send_print(input);
	send_br();
}
void Class_Serial::send_figure(uint8_t input){
	if((0 <= input)&&(input <= 9)){
		while( !((*UCSRnA) & 0b00100000 ) );//M܂őҋ@
		input += 48;
		*UDRn = input;
	}
}
void Class_Serial::send_br(){
	while( !((*UCSRnA) & 0b00100000 ) );//M܂őҋ@
	*UDRn = '\r';
	while( !((*UCSRnA) & 0b00100000 ) );//M܂őҋ@
	*UDRn = '\n';
}
void Class_Serial::send_num(int16_t input){
	bool zero_flag = false;
	uint16_t x;
	uint16_t waru = 10000;
	if(input < 0){
		send_char('-');
		input *= -1;
	}
	x = input/waru;
	for(;waru > 10;){
		if(x != 0 || zero_flag == true){
			send_figure(x);
			zero_flag = true;
		}
		input -= x*waru;
		waru /= 10;
		x = input/waru;
	}
	send_figure(x);
	input -= x*10;
	send_figure(input);
}
void Class_Serial::send_num(int32_t input){
	bool zero_flag = false;
	uint32_t x;
	uint32_t waru = 100000000;
	if(input < 0){
		send_char('-');
		input *= -1;
	}
	x = input/waru;
	for(;waru > 10;){
		if(x != 0 || zero_flag == true){
			send_figure(x);
			zero_flag = true;
		}
		input -= x*waru;
		waru /= 10;
		x = input/waru;
	}
	send_figure(x);
	input -= x*10;
	send_figure(input);
}
void Class_Serial::receive_enqueue(){
	if(queue_num < QUEUE_MAX-1){
		buffer[head] = *UDRn;
		//L[̐𑝂₵āAL[̏ꏊ1i߂
		queue_num++;
		head++;

		//L[ԍŌ܂Ői񂾂Aŏɖ߂
		if(head == QUEUE_MAX){
			head = 0;
		}
	}
}
uint8_t Class_Serial::read_dequeue(){
	uint8_t data = 0;
	if(queue_num > 0){
		data = buffer[tail];
		//L[̐炵āAL[̏ꏊ1i߂
		queue_num--;
		tail++;

		//L[ԍŌ܂Ői񂾂Aŏɖ߂
		if(tail == QUEUE_MAX){
			tail = 0;
		}
	}
	return data;
}
uint8_t Class_Serial::available(){
	return queue_num;
}
